package controller

import (
	"math"
	"strconv"

	"gitlab.com/mbugroup/lti-api.git/internal/modules/master/suppliers/dto"
	service "gitlab.com/mbugroup/lti-api.git/internal/modules/master/suppliers/services"
	validation "gitlab.com/mbugroup/lti-api.git/internal/modules/master/suppliers/validations"
	"gitlab.com/mbugroup/lti-api.git/internal/response"

	"github.com/gofiber/fiber/v2"
)

type SupplierController struct {
	SupplierService service.SupplierService
}

func NewSupplierController(supplierService service.SupplierService) *SupplierController {
	return &SupplierController{
		SupplierService: supplierService,
	}
}

func (u *SupplierController) GetAll(c *fiber.Ctx) error {
	query := &validation.Query{
		Page:     c.QueryInt("page", 1),
		Limit:    c.QueryInt("limit", 10),
		Search:   c.Query("search", ""),
		Category: c.Query("category", ""),
		Flag:     c.Query("flag", ""),
	}

	if query.Page < 1 || query.Limit < 1 {
		return fiber.NewError(fiber.StatusBadRequest, "page and limit must be greater than 0")
	}

	result, totalResults, err := u.SupplierService.GetAll(c, query)
	if err != nil {
		return err
	}

	return c.Status(fiber.StatusOK).
		JSON(response.SuccessWithPaginate[dto.SupplierListDTO]{
			Code:    fiber.StatusOK,
			Status:  "success",
			Message: "Get all suppliers successfully",
			Meta: response.Meta{
				Page:         query.Page,
				Limit:        query.Limit,
				TotalPages:   int64(math.Ceil(float64(totalResults) / float64(query.Limit))),
				TotalResults: totalResults,
			},
			Data: dto.ToSupplierListDTOs(result),
		})
}

func (u *SupplierController) GetOne(c *fiber.Ctx) error {
	param := c.Params("id")

	id, err := strconv.Atoi(param)
	if err != nil {
		return fiber.NewError(fiber.StatusBadRequest, "Invalid Id")
	}

	result, err := u.SupplierService.GetOne(c, uint(id))
	if err != nil {
		return err
	}

	return c.Status(fiber.StatusOK).
		JSON(response.Success{
			Code:    fiber.StatusOK,
			Status:  "success",
			Message: "Get supplier successfully",
			Data:    dto.ToSupplierDetailDTO(*result),
		})
}

func (u *SupplierController) CreateOne(c *fiber.Ctx) error {
	req := new(validation.Create)

	if err := c.BodyParser(req); err != nil {
		return fiber.NewError(fiber.StatusBadRequest, "Invalid request body")
	}

	result, err := u.SupplierService.CreateOne(c, req)
	if err != nil {
		return err
	}

	return c.Status(fiber.StatusCreated).
		JSON(response.Success{
			Code:    fiber.StatusCreated,
			Status:  "success",
			Message: "Create supplier successfully",
			Data:    dto.ToSupplierListDTO(*result),
		})
}

func (u *SupplierController) UpdateOne(c *fiber.Ctx) error {
	req := new(validation.Update)
	param := c.Params("id")

	id, err := strconv.Atoi(param)
	if err != nil {
		return fiber.NewError(fiber.StatusBadRequest, "Invalid Id")
	}

	if err := c.BodyParser(req); err != nil {
		return fiber.NewError(fiber.StatusBadRequest, "Invalid request body")
	}

	result, err := u.SupplierService.UpdateOne(c, req, uint(id))
	if err != nil {
		return err
	}

	return c.Status(fiber.StatusOK).
		JSON(response.Success{
			Code:    fiber.StatusOK,
			Status:  "success",
			Message: "Update supplier successfully",
			Data:    dto.ToSupplierListDTO(*result),
		})
}

func (u *SupplierController) DeleteOne(c *fiber.Ctx) error {
	param := c.Params("id")

	id, err := strconv.Atoi(param)
	if err != nil {
		return fiber.NewError(fiber.StatusBadRequest, "Invalid Id")
	}

	if err := u.SupplierService.DeleteOne(c, uint(id)); err != nil {
		return err
	}

	return c.Status(fiber.StatusOK).
		JSON(response.Common{
			Code:    fiber.StatusOK,
			Status:  "success",
			Message: "Delete supplier successfully",
		})
}
